unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, BubbleCh, ExtCtrls, TeeProcs, Chart, Menus,
  Math, ComCtrls;

const
  MaxPeoples = 1000;
  MaxMoneyExchange = 5;

type
  TIndividual = record
    Money: Integer;
  end;

  TPeoples = array [0..MaxPeoples - 1] of TIndividual;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Run1: TMenuItem;
    Stop1: TMenuItem;
    Step1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Chart1: TChart;
    Series1: TBubbleSeries;
    Chart2: TChart;
    Series2: TPieSeries;
    Step201: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Run1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure Step1Click(Sender: TObject);
    procedure Step201Click(Sender: TObject);
  Private
    { Private declarations }
    CurrentStep: Integer;
    Peoples, buff: TPeoples;
    IsRunning: Boolean;
    PieLabels: array [0..9] of String;
  Public
    { Public declarations }
    procedure RunCockshotteStep(var Peoples, buff: TPeoples);
    procedure DrawChart;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.DrawChart;
var
  i: Integer;
  Minimum, Maximum: Integer;
  OneBy10: Double;
  Counter: array [0..9] of Integer;
begin
  Chart1.Title.Caption := 'Step ' + IntToStr(CurrentStep);
  Chart2.Title.Caption := Chart1.Title.Caption;

  Series1.BeginUpdate;
  for I := 0 to MaxPeoples - 1 do
    Series1.YValues.Value[i] := Peoples[i].Money;
  Series1.EndUpdate;
  Series1.Repaint;

  Minimum := Peoples[0].Money;
  Maximum := Peoples[0].Money;
  for I := 1 to MaxPeoples - 1 do
    if Minimum > Peoples[i].Money then
      Minimum := Peoples[i].Money
    else
    if Maximum < Peoples[i].Money then
      Maximum := Peoples[i].Money;

  fillchar(Counter, sizeof(Counter), 0);
  OneBy10 := 9 / (Maximum - Minimum);
  try
    for I := 0 to MaxPeoples - 1 do
      Inc(Counter[round((Peoples[i].Money - Minimum) * OneBy10)]);
  except
    on E: Exception do ;
  end;

  Series2.BeginUpdate;
  Series2.Clear;
  for I := 0 to 9 do
    Series2.AddPie(Counter[i], PieLabels[i]);
  Series2.EndUpdate;
  Series2.Repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  Chart1.BufferedDisplay := True;
  Chart1.DoubleBuffered  := True;
  Series1.Clear;
  Chart2.BufferedDisplay := True;
  Chart2.DoubleBuffered  := True;
  Series2.Clear;

  Randomize;
  Series1.BeginUpdate;
  for I := 0 to MaxPeoples - 1 do
  begin
    Peoples[i].Money := 100;
    Series1.AddBubble(i, Peoples[i].Money, 2, '',
      rgb(random(255), random(255), random(255)));
  end;
  Series1.EndUpdate;

  Series2.BeginUpdate;
  for I := 0 to 9 do
  begin
    PieLabels[i] := Format('%d - %d', [i * 10, (i + 10) * 10]);
    Series2.AddPie(100, PieLabels[i]);
  end;
  Series2.EndUpdate;
end;

procedure TForm1.Run1Click(Sender: TObject);
var
  i: Integer;
begin
  IsRunning := True;
  while IsRunning do
  begin
    for I := 0 to 10 do
      RunCockshotteStep(Peoples, buff);
    DrawChart;
    Application.ProcessMessages;
  end;
end;

procedure TForm1.RunCockshotteStep(var Peoples, buff: TPeoples);
var
  i: Integer;
  client, delta: Integer;
begin
  inc(CurrentStep);
  move(Peoples, buff, sizeof(Peoples));
  for I := 0 to MaxPeoples - 1 do
  begin
    client := random(MaxPeoples);
    delta  := min(Peoples[i].Money, 1 + random(MaxMoneyExchange));

    Peoples[client].Money := Peoples[client].Money + delta;
    Peoples[i].Money := Peoples[i].Money - delta;
  end;
end;

procedure TForm1.Step1Click(Sender: TObject);
begin
  RunCockshotteStep(Peoples, buff);
  DrawChart;
end;

procedure TForm1.Step201Click(Sender: TObject);
var
  i: Integer;
begin
  for I := 1 to 10 do
    Step1Click(Nil);
end;

procedure TForm1.Stop1Click(Sender: TObject);
begin
  IsRunning := False;
end;

end.
